"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/builtin/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/builtin/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/builtin/objectWithoutProperties"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/builtin/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/builtin/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/builtin/possibleConstructorReturn"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/builtin/inherits"));

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _tinycolor = _interopRequireDefault(require("tinycolor2"));

var _withStyles = _interopRequireDefault(require("../styles/withStyles"));

var _AlphaPicker = _interopRequireDefault(require("../AlphaPicker"));

var _FormControl = _interopRequireDefault(require("../FormControl"));

var _InputLabel = _interopRequireDefault(require("../InputLabel"));

var _ColorInput = _interopRequireDefault(require("../ColorInput"));

var _FormHelperText = _interopRequireDefault(require("../FormHelperText"));

var styles = function styles(theme) {
  return {
    root: {
      display: 'grid',
      grid: "\n      \"label label\"\n      \"alpha color\"\n      / 1fr 32px\n    ",
      gridColumnGap: "".concat(theme.spacing.small, "px"),
      alignItems: 'center',
      minWidth: 167
    },
    label: {
      gridArea: 'label'
    },
    alphaInput: {
      gridArea: 'alpha'
    },
    colorInput: {
      gridArea: 'color',
      minWidth: 32
    }
  };
};

var AlphaInput =
/*#__PURE__*/
function (_React$Component) {
  (0, _inherits2.default)(AlphaInput, _React$Component);

  function AlphaInput() {
    var _ref;

    var _temp, _this;

    (0, _classCallCheck2.default)(this, AlphaInput);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return (0, _possibleConstructorReturn2.default)(_this, (_temp = _this = (0, _possibleConstructorReturn2.default)(this, (_ref = AlphaInput.__proto__ || Object.getPrototypeOf(AlphaInput)).call.apply(_ref, [this].concat(args))), _this.getRGBA = function (newColor, newAlpha) {
      var color = (0, _tinycolor.default)(newColor || _this.props.value);
      var alpha = newAlpha || (0, _tinycolor.default)(_this.props.value).getAlpha();
      return color.setAlpha(alpha).toRgbString();
    }, _this.handleAlphaChange = function (_ref2) {
      var rgb = _ref2.rgb;
      return _this.props.onChange(_this.getRGBA(null, rgb.a));
    }, _this.handleColorChange = function (color) {
      return _this.props.onChange(_this.getRGBA(color, null));
    }, _temp));
  }

  (0, _createClass2.default)(AlphaInput, [{
    key: "render",
    value: function render() {
      var _props = this.props,
          cancelButton = _props.cancelButton,
          classes = _props.classes,
          className = _props.className,
          confirmButton = _props.confirmButton,
          disabled = _props.disabled,
          helperText = _props.helperText,
          label = _props.label,
          onChange = _props.onChange,
          value = _props.value,
          other = (0, _objectWithoutProperties2.default)(_props, ["cancelButton", "classes", "className", "confirmButton", "disabled", "helperText", "label", "onChange", "value"]);
      return _react.default.createElement(_FormControl.default, (0, _extends2.default)({
        className: (0, _classnames.default)(classes.root, className)
      }, other), label && _react.default.createElement(_InputLabel.default, {
        className: classes.label
      }, label), _react.default.createElement(_AlphaPicker.default, {
        className: classes.alphaInput,
        color: value,
        onChange: this.handleAlphaChange,
        disabled: disabled
      }), _react.default.createElement(_ColorInput.default, {
        className: classes.colorInput,
        value: (0, _tinycolor.default)(value).toHexString(),
        onChange: this.handleColorChange,
        confirmButton: confirmButton,
        cancelButton: cancelButton,
        disabled: disabled
      }), helperText && _react.default.createElement(_FormHelperText.default, null, helperText));
    }
  }]);
  return AlphaInput;
}(_react.default.Component);

AlphaInput.propTypes = process.env.NODE_ENV !== "production" ? {
  cancelButton: _propTypes.default.node.isRequired,
  classes: _propTypes.default.object.isRequired,
  className: _propTypes.default.string,
  confirmButton: _propTypes.default.node.isRequired,
  disabled: _propTypes.default.bool,
  helperText: _propTypes.default.node,
  label: _propTypes.default.node,
  onChange: _propTypes.default.func,
  style: _propTypes.default.object,
  value: _propTypes.default.string
} : {};
AlphaInput.defaultProps = {
  disabled: false
};

var _default = (0, _withStyles.default)(styles)(AlphaInput);

exports.default = _default;