"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/builtin/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime/helpers/builtin/toConsumableArray"));

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/builtin/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/builtin/objectWithoutProperties"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/builtin/defineProperty"));

var _objectSpread3 = _interopRequireDefault(require("@babel/runtime/helpers/builtin/objectSpread"));

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _withStyles = _interopRequireDefault(require("../styles/withStyles"));

var _createPalette = require("../styles/createPalette");

var _helpers = require("../utils/helpers");

var styles = function styles(theme) {
  return (0, _objectSpread3.default)({
    root: (0, _defineProperty2.default)({
      position: 'relative',
      border: theme.borders[1],
      padding: theme.spacing.medium,
      backgroundColor: theme.palette.common.white,
      boxShadow: theme.shadows[1],
      boxSizing: 'border-box'
    }, theme.breakpoints.down('sm'), {
      padding: theme.spacing.small
    }),
    disableGutters: {
      padding: 0
    },
    filled: {
      border: 'none'
    }
  }, _createPalette.colors.reduce(function (classes, color) {
    var contrastText = theme.palette[color].contrastText;
    var gradient = theme.palette.gradients[color];
    return (0, _objectSpread3.default)({}, classes, (0, _defineProperty2.default)({}, "color".concat((0, _helpers.capitalize)(color)), {
      background: gradient,
      color: contrastText
    }));
  }, {}));
};

function Box(_ref) {
  var _classNames;

  var className = _ref.className,
      classes = _ref.classes,
      fillColor = _ref.fillColor,
      disableGutters = _ref.disableGutters,
      Component = _ref.component,
      other = (0, _objectWithoutProperties2.default)(_ref, ["className", "classes", "fillColor", "disableGutters", "component"]);
  var filled = fillColor !== 'default';
  return _react.default.createElement(Component, (0, _extends2.default)({
    className: (0, _classnames.default)(classes.root, (_classNames = {}, (0, _defineProperty2.default)(_classNames, classes.filled, filled), (0, _defineProperty2.default)(_classNames, classes["color".concat((0, _helpers.capitalize)(fillColor))], filled), (0, _defineProperty2.default)(_classNames, classes.disableGutters, disableGutters), _classNames), className)
  }, other));
}

Box.propTypes = process.env.NODE_ENV !== "production" ? {
  classes: _propTypes.default.object.isRequired,
  className: _propTypes.default.string,
  component: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.func]),
  disableGutters: _propTypes.default.bool,
  fillColor: _propTypes.default.oneOf(['default'].concat((0, _toConsumableArray2.default)(_createPalette.colors)))
} : {};
Box.defaultProps = {
  component: 'div',
  disableGutters: false,
  fillColor: 'default'
};

var _default = (0, _withStyles.default)(styles)(Box);

exports.default = _default;