"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/builtin/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _objectSpread2 = _interopRequireDefault(require("@babel/runtime/helpers/builtin/objectSpread"));

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/builtin/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/builtin/objectWithoutProperties"));

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _withStyles = _interopRequireDefault(require("../styles/withStyles"));

var _ButtonBase = _interopRequireDefault(require("../ButtonBase"));

function BoxTab(_ref) {
  var classes = _ref.classes,
      selected = _ref.selected,
      other = (0, _objectWithoutProperties2.default)(_ref, ["classes", "selected"]);
  return _react.default.createElement(_ButtonBase.default, (0, _extends2.default)({
    className: (0, _classnames.default)(classes.root, selected && classes.selected)
  }, other));
}

BoxTab.propTypes = process.env.NODE_ENV !== "production" ? {
  classes: _propTypes.default.object.isRequired,
  selected: _propTypes.default.bool.isRequired
} : {};

var styles = function styles(theme) {
  return {
    root: (0, _objectSpread2.default)({}, theme.typography.button, {
      width: 38,
      height: '100%',
      border: theme.borders[1],
      borderBottom: 'none',
      backgroundColor: theme.palette.common.white,
      boxShadow: theme.shadows[1],
      cursor: 'pointer',
      '&:not(:first-child)': {
        marginLeft: theme.spacing.xsmall
      }
    }),
    selected: {
      color: theme.palette.primary.main,
      cursor: 'default',
      pointerEvents: 'none',
      boxShadow: [theme.shadows[1], "0 2px 0 0 ".concat(theme.palette.primary.main, " inset")],
      '&::after': {
        content: '""',
        display: 'block',
        position: 'absolute',
        bottom: -1,
        left: 0,
        right: 0,
        height: 2,
        backgroundColor: theme.palette.common.white,
        zIndex: 1
      }
    }
  };
};

var _default = (0, _withStyles.default)(styles)(BoxTab);

exports.default = _default;