"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/builtin/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _withStyles = _interopRequireDefault(require("../styles/withStyles"));

function BoxTabs(_ref) {
  var classes = _ref.classes,
      noSpace = _ref.noSpace,
      children = _ref.children,
      value = _ref.value;
  return _react.default.createElement("div", {
    className: (0, _classnames.default)(classes.root, noSpace && classes.noSpace)
  }, _react.default.Children.map(children, function (child, index) {
    if (!_react.default.isValidElement(child)) {
      return null;
    }

    var childValue = child.props.value || index;
    var selected = childValue === value;
    return _react.default.cloneElement(child, {
      selected: selected
    });
  }));
}

BoxTabs.propTypes = process.env.NODE_ENV !== "production" ? {
  children: _propTypes.default.node.isRequired,
  classes: _propTypes.default.object.isRequired,
  noSpace: _propTypes.default.bool,
  value: _propTypes.default.any.isRequired
} : {};
BoxTabs.defaultProps = {
  noSpace: false
};
var styles = {
  root: {
    display: 'flex',
    height: 32
  },
  noSpace: {
    marginTop: -32
  }
};

var _default = (0, _withStyles.default)(styles)(BoxTabs);

exports.default = _default;