"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/builtin/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/builtin/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/builtin/objectWithoutProperties"));

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _withStyles = _interopRequireDefault(require("../styles/withStyles"));

var _createPalette = require("../styles/createPalette");

var styles = {
  root: {
    display: 'inline-block'
  }
};

function ButtonGroup(_ref) {
  var className = _ref.className,
      classes = _ref.classes,
      onChange = _ref.onChange,
      color = _ref.color,
      value = _ref.value,
      children = _ref.children,
      other = (0, _objectWithoutProperties2.default)(_ref, ["className", "classes", "onChange", "color", "value", "children"]);
  return _react.default.createElement("div", (0, _extends2.default)({
    className: (0, _classnames.default)(classes.root, className)
  }, other), _react.default.Children.map(children, function (child) {
    if (!_react.default.isValidElement(child)) {
      return null;
    }

    return _react.default.cloneElement(child, {
      onChange: onChange,
      color: child.props.color || color,
      selected: child.props.value === value
    });
  }));
}

ButtonGroup.propTypes = process.env.NODE_ENV !== "production" ? {
  children: _propTypes.default.node,
  classes: _propTypes.default.object.isRequired,
  className: _propTypes.default.string,
  color: _propTypes.default.oneOf(_createPalette.colors),
  onChange: _propTypes.default.func.isRequired,
  value: _propTypes.default.any.isRequired
} : {};
ButtonGroup.defaultProps = {
  color: 'primary'
};

var _default = (0, _withStyles.default)(styles)(ButtonGroup);

exports.default = _default;