"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/builtin/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/builtin/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/builtin/objectWithoutProperties"));

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _withStyles = _interopRequireDefault(require("../styles/withStyles"));

var _Button = _interopRequireDefault(require("../Button"));

var styles = function styles(theme) {
  return {
    root: {
      '&:not(:last-of-type)': {
        borderTopRightRadius: 0,
        borderBottomRightRadius: 0,
        borderRight: 'none'
      },
      '&:not(:first-of-type)': {
        borderTopLeftRadius: 0,
        borderBottomLeftRadius: 0,
        borderLeft: 'none'
      }
    },
    selected: {
      padding: [[theme.spacing.unit, theme.spacing.small - 1]]
    }
  };
};

function ButtonGroupOption(props) {
  var className = props.className,
      classes = props.classes,
      onChange = props.onChange,
      value = props.value,
      selected = props.selected,
      other = (0, _objectWithoutProperties2.default)(props, ["className", "classes", "onChange", "value", "selected"]);
  return _react.default.createElement(_Button.default, (0, _extends2.default)({
    className: (0, _classnames.default)(classes.root, selected && classes.selected, className),
    onClick: function onClick() {
      return onChange(value);
    },
    variant: selected ? 'raised' : 'outlined'
  }, other));
}

ButtonGroupOption.propTypes = process.env.NODE_ENV !== "production" ? {
  classes: _propTypes.default.object.isRequired,
  className: _propTypes.default.string,
  onChange: _propTypes.default.func.isRequired,
  selected: _propTypes.default.bool.isRequired,
  value: _propTypes.default.any.isRequired
} : {};

var _default = (0, _withStyles.default)(styles)(ButtonGroupOption);

exports.default = _default;