"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/builtin/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/builtin/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/builtin/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/builtin/objectWithoutProperties"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/builtin/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/builtin/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/builtin/possibleConstructorReturn"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/builtin/inherits"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _withStyles = _interopRequireDefault(require("../styles/withStyles"));

var _Button = _interopRequireDefault(require("../Button"));

var _ArrowDropDown = _interopRequireDefault(require("../icons/ArrowDropDown"));

var _Typography = _interopRequireDefault(require("../Typography"));

var _Popover = _interopRequireDefault(require("../Popover"));

var styles = function styles(theme) {
  return {
    root: {
      color: 'white',
      position: 'relative',
      paddingRight: theme.spacing.medium + theme.spacing.small
    },
    label: {
      width: '100%'
    },
    icon: {
      position: 'absolute',
      right: theme.spacing.xsmall
    },
    menu: {
      border: theme.borders[1]
    }
  };
};

var ButtonMenu =
/*#__PURE__*/
function (_Component) {
  (0, _inherits2.default)(ButtonMenu, _Component);

  function ButtonMenu() {
    (0, _classCallCheck2.default)(this, ButtonMenu);
    return (0, _possibleConstructorReturn2.default)(this, (ButtonMenu.__proto__ || Object.getPrototypeOf(ButtonMenu)).apply(this, arguments));
  }

  (0, _createClass2.default)(ButtonMenu, [{
    key: "render",
    value: function render() {
      var _this = this;

      var _props = this.props,
          label = _props.label,
          className = _props.className,
          classes = _props.classes,
          children = _props.children,
          onOpen = _props.onOpen,
          onClose = _props.onClose,
          open = _props.open,
          other = (0, _objectWithoutProperties2.default)(_props, ["label", "className", "classes", "children", "onOpen", "onClose", "open"]);
      return _react.default.createElement(_Button.default, (0, _extends2.default)({
        className: (0, _classnames.default)(classes.root, className),
        onClick: open ? onClose : onOpen,
        buttonRef: function buttonRef(node) {
          _this.button = node;
        }
      }, other), _react.default.createElement(_Typography.default, {
        variant: "button",
        color: "inherit"
      }, label), _react.default.createElement(_ArrowDropDown.default, {
        classes: {
          root: classes.icon
        }
      }), _react.default.createElement(_Popover.default, {
        className: classes.menu,
        anchorEl: this.button,
        open: open,
        onClose: onClose,
        anchorOrigin: {
          vertical: 'bottom',
          horizontal: 'center'
        },
        transformOrigin: {
          vertical: 'top',
          horizontal: 'center'
        },
        getContentAnchorEl: null,
        PaperProps: {
          style: {
            width: this.button && this.button.clientWidth
          }
        }
      }, children));
    }
  }]);
  return ButtonMenu;
}(_react.Component);

ButtonMenu.propTypes = process.env.NODE_ENV !== "production" ? {
  children: _propTypes.default.node,
  classes: _propTypes.default.object.isRequired,
  className: _propTypes.default.string,
  label: _propTypes.default.node.isRequired,
  onClose: _propTypes.default.func,
  onOpen: _propTypes.default.func,
  open: _propTypes.default.bool
} : {};
ButtonMenu.defaultProps = {
  open: false
};

var _default = (0, _withStyles.default)(styles)(ButtonMenu);

exports.default = _default;