"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/builtin/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/builtin/objectWithoutProperties"));

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _withStyles = _interopRequireDefault(require("../styles/withStyles"));

var _FormControlLabel = _interopRequireDefault(require("../FormControlLabel"));

var _FormControl = _interopRequireDefault(require("../FormControl"));

var _InputLabel = _interopRequireDefault(require("../InputLabel"));

var _Checkbox = _interopRequireDefault(require("../Checkbox"));

var _FormHelperText = _interopRequireDefault(require("../FormHelperText"));

var styles = {
  formControlLabel: {
    marginRight: 0
  }
};

function CheckboxInput(_ref) {
  var classes = _ref.classes,
      className = _ref.className,
      disabled = _ref.disabled,
      helperText = _ref.helperText,
      error = _ref.error,
      fullWidth = _ref.fullWidth,
      label = _ref.label,
      margin = _ref.margin,
      required = _ref.required,
      text = _ref.text,
      other = (0, _objectWithoutProperties2.default)(_ref, ["classes", "className", "disabled", "helperText", "error", "fullWidth", "label", "margin", "required", "text"]);
  return _react.default.createElement(_FormControl.default, {
    className: className,
    disabled: disabled,
    error: error,
    fullWidth: fullWidth,
    margin: margin,
    required: required
  }, label && _react.default.createElement(_InputLabel.default, null, label), _react.default.createElement(_FormControlLabel.default, {
    className: classes.formControlLabel,
    control: _react.default.createElement(_Checkbox.default, other),
    label: text
  }), helperText && _react.default.createElement(_FormHelperText.default, null, helperText));
}

CheckboxInput.propTypes = process.env.NODE_ENV !== "production" ? {
  classes: _propTypes.default.object.isRequired,
  className: _propTypes.default.string,
  disabled: _propTypes.default.bool,
  error: _propTypes.default.bool,
  fullWidth: _propTypes.default.bool,
  helperText: _propTypes.default.node,
  label: _propTypes.default.node,
  margin: _propTypes.default.oneOf(['none', 'dense', 'normal']),
  required: _propTypes.default.bool,
  text: _propTypes.default.node
} : {};
CheckboxInput.defaultProps = {
  disabled: false,
  error: false,
  fullWidth: false,
  margin: 'none',
  required: false
};

var _default = (0, _withStyles.default)(styles)(CheckboxInput);

exports.default = _default;