"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/builtin/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/builtin/objectWithoutProperties"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/builtin/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/builtin/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/builtin/possibleConstructorReturn"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/builtin/inherits"));

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _withStyles = _interopRequireDefault(require("../styles/withStyles"));

var _FormControl = _interopRequireDefault(require("../FormControl"));

var _InputLabel = _interopRequireDefault(require("../InputLabel"));

var _Popover = _interopRequireDefault(require("../Popover"));

var _ColorPicker = _interopRequireDefault(require("../ColorPicker"));

var _Button = _interopRequireDefault(require("../Button"));

var _FormHelperText = _interopRequireDefault(require("../FormHelperText"));

var styles = function styles(theme) {
  return {
    disabled: {
      filter: 'grayscale(100%)',
      pointerEvents: 'none',
      opacity: 0.7
    },
    preview: {
      width: '100%',
      minWidth: 167,
      height: 32,
      borderRadius: 2,
      overflow: 'hidden'
    },
    triggerButton: {
      width: '100%',
      height: '100%',
      padding: 0,
      outline: 'none',
      cursor: 'pointer',
      backgroundColor: 'transparent',
      willChange: 'background-color',
      transition: "background-color ".concat(theme.transitions.duration.shorter, "ms"),
      border: '1px solid rgba(0,0,0,0.25)',
      '&:hover': {
        backgroundColor: 'rgba(255,255,255,0.25)'
      },
      '&:active': {
        backgroundColor: 'rgba(0,0,0,0.1)'
      }
    },
    popover: {
      border: theme.borders[1]
    },
    colorPickerButton: {
      margin: theme.spacing.xsmall,
      float: 'right',
      '&:not(:first-of-type)': {
        marginRight: 0
      }
    }
  };
};

var ColorInput =
/*#__PURE__*/
function (_React$Component) {
  (0, _inherits2.default)(ColorInput, _React$Component);

  function ColorInput() {
    var _ref;

    var _temp, _this;

    (0, _classCallCheck2.default)(this, ColorInput);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return (0, _possibleConstructorReturn2.default)(_this, (_temp = _this = (0, _possibleConstructorReturn2.default)(this, (_ref = ColorInput.__proto__ || Object.getPrototypeOf(ColorInput)).call.apply(_ref, [this].concat(args))), _this.state = {
      expanded: false
    }, _this.handleOpen = function () {
      return _this.setState({
        expanded: true,
        anchorEl: _this.button,
        previousValue: _this.props.value
      });
    }, _this.handleClose = function () {
      return _this.setState({
        expanded: false
      });
    }, _this.handleCancel = function () {
      _this.props.onChange(_this.state.previousValue);

      _this.handleClose();
    }, _temp));
  }

  (0, _createClass2.default)(ColorInput, [{
    key: "render",
    value: function render() {
      var _this2 = this;

      var _state = this.state,
          expanded = _state.expanded,
          anchorEl = _state.anchorEl;
      var _props = this.props,
          cancelButton = _props.cancelButton,
          className = _props.className,
          classes = _props.classes,
          confirmButton = _props.confirmButton,
          disabled = _props.disabled,
          helperText = _props.helperText,
          label = _props.label,
          onChange = _props.onChange,
          value = _props.value,
          other = (0, _objectWithoutProperties2.default)(_props, ["cancelButton", "className", "classes", "confirmButton", "disabled", "helperText", "label", "onChange", "value"]);
      return _react.default.createElement(_FormControl.default, other, label && _react.default.createElement(_InputLabel.default, null, label), _react.default.createElement("div", {
        className: (0, _classnames.default)(classes.preview, className, disabled && classes.disabled),
        style: {
          backgroundColor: value
        }
      }, _react.default.createElement("button", {
        type: "button",
        className: classes.triggerButton,
        onClick: this.handleOpen,
        ref: function ref(button) {
          _this2.button = button;
        }
      }), _react.default.createElement(_Popover.default, {
        className: classes.popover,
        open: expanded,
        anchorEl: anchorEl,
        onClose: this.handleCancel,
        PaperProps: {
          style: {
            width: anchorEl && anchorEl.clientWidth,
            minWidth: 220
          }
        },
        anchorOrigin: {
          vertical: 'bottom',
          horizontal: 'center'
        },
        transformOrigin: {
          vertical: 'top',
          horizontal: 'center'
        }
      }, _react.default.createElement(_ColorPicker.default, {
        onChange: onChange,
        color: value
      }), _react.default.createElement(_Button.default, {
        type: "button",
        className: classes.colorPickerButton,
        onClick: this.handleClose,
        color: "primary"
      }, confirmButton), _react.default.createElement(_Button.default, {
        type: "button",
        className: classes.colorPickerButton,
        onClick: this.handleCancel,
        color: "primary",
        variant: "outlined"
      }, cancelButton))), helperText && _react.default.createElement(_FormHelperText.default, null, helperText));
    }
  }]);
  return ColorInput;
}(_react.default.Component);

ColorInput.propTypes = process.env.NODE_ENV !== "production" ? {
  cancelButton: _propTypes.default.node.isRequired,
  classes: _propTypes.default.object.isRequired,
  className: _propTypes.default.string,
  confirmButton: _propTypes.default.node.isRequired,
  disabled: _propTypes.default.bool,
  helperText: _propTypes.default.node,
  label: _propTypes.default.node,
  onChange: _propTypes.default.func,
  value: _propTypes.default.string
} : {};
ColorInput.defaultProps = {
  disabled: false
};

var _default = (0, _withStyles.default)(styles)(ColorInput);

exports.default = _default;