"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/builtin/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _objectSpread2 = _interopRequireDefault(require("@babel/runtime/helpers/builtin/objectSpread"));

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _Sketch = _interopRequireDefault(require("react-color/lib/Sketch"));

var _withStyles = _interopRequireDefault(require("../styles/withStyles"));

function ColorPicker(_ref) {
  var classes = _ref.classes,
      _onChange = _ref.onChange,
      color = _ref.color;
  return _react.default.createElement(_Sketch.default, {
    color: color,
    className: classes.picker,
    presetColors: [],
    onChange: function onChange(_ref2) {
      var hex = _ref2.hex;
      return _onChange(hex);
    },
    disableAlpha: true
  });
}

ColorPicker.propTypes = process.env.NODE_ENV !== "production" ? (0, _objectSpread2.default)({}, _Sketch.default.propTypes, {
  classes: _propTypes.default.object.isRequired,
  onChange: _propTypes.default.func.isRequired
}) : {};
ColorPicker.defaultProps = (0, _objectSpread2.default)({}, _Sketch.default.defaultProps, {
  color: '#ccc'
});

var styles = function styles(theme) {
  return {
    picker: {
      boxShadow: 'none !important',
      boxSizing: 'border-box !important',
      borderRadius: '0 !important',
      fontFamily: theme.typography.fontFamily,
      width: '100% !important',
      '& input, & span': {
        width: '100% !important',
        fontSize: '14px !important',
        outline: 'none'
      }
    }
  };
};

var _default = (0, _withStyles.default)(styles)(ColorPicker);

exports.default = _default;