"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/builtin/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/builtin/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/builtin/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/builtin/objectWithoutProperties"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/builtin/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/builtin/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/builtin/possibleConstructorReturn"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/builtin/inherits"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _moment = _interopRequireDefault(require("moment"));

var _classnames = _interopRequireDefault(require("classnames"));

var _reactIntl = require("react-intl");

var _Today = _interopRequireDefault(require("../icons/Today"));

var _Cancel = _interopRequireDefault(require("../icons/Cancel"));

var _DatePicker = _interopRequireDefault(require("../DatePicker"));

var _Dialog = _interopRequireWildcard(require("../Dialog"));

var _TextField = _interopRequireDefault(require("../TextField"));

var _Input = require("../Input");

var _IconButton = _interopRequireDefault(require("../IconButton"));

var _styles = require("../styles");

var styles = function styles(theme) {
  return {
    cancelButtom: {
      width: 32,
      height: 32,
      transition: theme.transitions.create(['opacity', 'transform'], {
        duration: theme.transitions.duration.shortest,
        easing: theme.transitions.easing.sharp
      })
    },
    cancelButtomHidden: {
      transform: 'scale(.25)',
      opacity: 0
    },
    cancelIcon: {
      width: theme.spacing.small,
      height: theme.spacing.small
    }
  };
};

var _ref2 = _react.default.createElement(_Input.InputAdornment, {
  position: "start"
}, _react.default.createElement(_Today.default, null));

var DateInput =
/*#__PURE__*/
function (_Component) {
  (0, _inherits2.default)(DateInput, _Component);

  function DateInput() {
    var _ref;

    var _temp, _this;

    (0, _classCallCheck2.default)(this, DateInput);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return (0, _possibleConstructorReturn2.default)(_this, (_temp = _this = (0, _possibleConstructorReturn2.default)(this, (_ref = DateInput.__proto__ || Object.getPrototypeOf(DateInput)).call.apply(_ref, [this].concat(args))), _this.state = {
      dialog: false
    }, _this.handleChange = function (value) {
      _this.toggleDialog();

      _this.props.onChange(value);
    }, _this.toggleDialog = function () {
      return _this.setState({
        dialog: !_this.state.dialog
      });
    }, _this.handleDialogClose = function () {
      var onBlur = _this.props.onBlur;

      _this.toggleDialog();

      if (onBlur) {
        onBlur();
      }
    }, _this.handleTextFieldClick = _this.toggleDialog, _this.handleCancelClick = function (event) {
      event.stopPropagation();

      _this.props.onChange('');
    }, _this.renderDateText = function (date) {
      return date ? (0, _moment.default)(date).format('L') : '';
    }, _temp));
  }

  (0, _createClass2.default)(DateInput, [{
    key: "render",
    value: function render() {
      var _props = this.props,
          classes = _props.classes,
          disabled = _props.disabled,
          endOfDay = _props.endOfDay,
          intl = _props.intl,
          label = _props.label,
          maxDate = _props.maxDate,
          minDate = _props.minDate,
          onBlur = _props.onBlur,
          onChange = _props.onChange,
          value = _props.value,
          other = (0, _objectWithoutProperties2.default)(_props, ["classes", "disabled", "endOfDay", "intl", "label", "maxDate", "minDate", "onBlur", "onChange", "value"]);
      var dialog = this.state.dialog;
      var initialValue = value ? new Date(value) : undefined;
      return _react.default.createElement(_react.Fragment, null, _react.default.createElement(_TextField.default, (0, _extends2.default)({
        label: label,
        value: this.renderDateText(value),
        onClick: disabled ? undefined : this.handleTextFieldClick,
        disabled: disabled,
        InputProps: {
          startAdornment: _ref2,
          endAdornment: _react.default.createElement(_Input.InputAdornment, {
            position: "end"
          }, _react.default.createElement(_IconButton.default, {
            className: (0, _classnames.default)(classes.cancelButtom, (!value || disabled) && classes.cancelButtomHidden),
            disabled: !value || disabled,
            onClick: this.handleCancelClick
          }, _react.default.createElement(_Cancel.default, {
            className: classes.cancelIcon
          })))
        }
      }, other)), _react.default.createElement(_Dialog.default, {
        open: dialog,
        onClose: this.handleDialogClose
      }, _react.default.createElement(_Dialog.DialogTitle, null, label), _react.default.createElement(_Dialog.DialogContent, null, _react.default.createElement(_DatePicker.default, {
        value: initialValue,
        onChange: this.handleChange,
        language: intl.locale,
        minDate: minDate,
        maxDate: maxDate,
        endOfDay: endOfDay
      }))));
    }
  }]);
  return DateInput;
}(_react.Component);

DateInput.propTypes = process.env.NODE_ENV !== "production" ? {
  classes: _propTypes.default.object.isRequired,
  disabled: _propTypes.default.bool,
  endOfDay: _propTypes.default.bool,
  intl: _propTypes.default.object.isRequired,
  label: _propTypes.default.node.isRequired,
  maxDate: _propTypes.default.instanceOf(Date),
  minDate: _propTypes.default.instanceOf(Date),
  onBlur: _propTypes.default.func,
  onChange: _propTypes.default.func.isRequired,
  value: _propTypes.default.oneOfType([_propTypes.default.object, _propTypes.default.string]).isRequired
} : {};
DateInput.defaultProps = {
  endOfDay: false
};

var _default = (0, _reactIntl.injectIntl)((0, _styles.withStyles)(styles)(DateInput));

exports.default = _default;