"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/builtin/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/builtin/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/builtin/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/builtin/objectWithoutProperties"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/builtin/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/builtin/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/builtin/possibleConstructorReturn"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/builtin/inherits"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _moment = _interopRequireDefault(require("moment"));

var _classnames = _interopRequireDefault(require("classnames"));

var _reactIntl = require("react-intl");

var _Today = _interopRequireDefault(require("../icons/Today"));

var _Cancel = _interopRequireDefault(require("../icons/Cancel"));

var _DatePicker = require("../DatePicker");

var _Button = _interopRequireDefault(require("../Button"));

var _Dialog = _interopRequireWildcard(require("../Dialog"));

var _TextField = _interopRequireDefault(require("../TextField"));

var _Input = require("../Input");

var _IconButton = _interopRequireDefault(require("../IconButton"));

var _styles = require("../styles");

var styles = function styles(theme) {
  return {
    cancelButtom: {
      width: 32,
      height: 32,
      transition: theme.transitions.create(['opacity', 'transform'], {
        duration: theme.transitions.duration.shortest,
        easing: theme.transitions.easing.sharp
      })
    },
    cancelButtomHidden: {
      transform: 'scale(.25)',
      opacity: 0
    },
    cancelIcon: {
      width: theme.spacing.small,
      height: theme.spacing.small
    }
  };
};

var _ref2 = _react.default.createElement(_Input.InputAdornment, {
  position: "start"
}, _react.default.createElement(_Today.default, null));

var DateRangeInput =
/*#__PURE__*/
function (_Component) {
  (0, _inherits2.default)(DateRangeInput, _Component);

  function DateRangeInput() {
    var _ref;

    var _temp, _this;

    (0, _classCallCheck2.default)(this, DateRangeInput);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return (0, _possibleConstructorReturn2.default)(_this, (_temp = _this = (0, _possibleConstructorReturn2.default)(this, (_ref = DateRangeInput.__proto__ || Object.getPrototypeOf(DateRangeInput)).call.apply(_ref, [this].concat(args))), _this.state = {
      dialog: false,
      value: {}
    }, _this.handleChange = function (value) {
      return _this.setState({
        value: value
      });
    }, _this.handleConfirmationClick = function () {
      _this.toggleDialog();

      _this.props.onChange(_this.state.value);
    }, _this.toggleDialog = function () {
      var dialog = _this.state.dialog;

      _this.setState({
        dialog: !dialog
      });
    }, _this.handleCancelClick = _this.toggleDialog, _this.handleDialogClose = function () {
      var onBlur = _this.props.onBlur;

      _this.toggleDialog();

      if (onBlur) {
        onBlur();
      }
    }, _this.handleTextFieldClick = _this.toggleDialog, _this.handleCancelClick = function (event) {
      event.stopPropagation();

      _this.props.onChange('');
    }, _this.renderDateText = function (startDate, endDate, dateRangeMessageId) {
      if (!startDate || !endDate) {
        return '';
      }

      var intl = _this.props.intl;
      var intlStartDate = (0, _moment.default)(startDate).format('L');
      var intlEndDate = (0, _moment.default)(endDate).format('L');

      if (intlStartDate === intlEndDate) {
        return intlStartDate;
      }

      if (dateRangeMessageId) {
        return intl.formatMessage({
          id: dateRangeMessageId,
          values: {
            startDate: startDate,
            endDate: endDate
          }
        });
      }

      return "".concat(intlStartDate, " - ").concat(intlEndDate);
    }, _temp));
  }

  (0, _createClass2.default)(DateRangeInput, [{
    key: "render",
    value: function render() {
      var _props = this.props,
          cancelButton = _props.cancelButton,
          classes = _props.classes,
          confirmButton = _props.confirmButton,
          dateRangeMessageId = _props.dateRangeMessageId,
          disabled = _props.disabled,
          intl = _props.intl,
          label = _props.label,
          maxDate = _props.maxDate,
          minDate = _props.minDate,
          onBlur = _props.onBlur,
          onChange = _props.onChange,
          _props$value = _props.value,
          start = _props$value.start,
          end = _props$value.end,
          other = (0, _objectWithoutProperties2.default)(_props, ["cancelButton", "classes", "confirmButton", "dateRangeMessageId", "disabled", "intl", "label", "maxDate", "minDate", "onBlur", "onChange", "value"]);
      var dialog = this.state.dialog;
      var initialStart = start ? new Date(start) : undefined;
      var initialEnd = end ? new Date(end) : undefined;
      return _react.default.createElement(_react.Fragment, null, _react.default.createElement(_TextField.default, (0, _extends2.default)({
        label: label,
        value: this.renderDateText(start, end, dateRangeMessageId),
        onClick: disabled ? undefined : this.handleTextFieldClick,
        disabled: disabled,
        InputProps: {
          startAdornment: _ref2,
          endAdornment: _react.default.createElement(_Input.InputAdornment, {
            position: "end"
          }, _react.default.createElement(_IconButton.default, {
            className: (0, _classnames.default)(classes.cancelButtom, (!start || !end || disabled) && classes.cancelButtomHidden),
            disabled: !start || !end || disabled,
            onClick: this.handleCancelClick
          }, _react.default.createElement(_Cancel.default, {
            className: classes.cancelIcon
          })))
        }
      }, other)), _react.default.createElement(_Dialog.default, {
        open: dialog,
        onClose: this.handleDialogClose,
        maxWidth: "md"
      }, _react.default.createElement(_Dialog.DialogCloseButton, {
        onClose: this.handleDialogClose
      }), _react.default.createElement(_Dialog.DialogTitle, null, label), _react.default.createElement(_Dialog.DialogContent, null, _react.default.createElement(_DatePicker.DateRangePicker, {
        startDate: initialStart,
        endDate: initialEnd,
        minDate: minDate,
        maxDate: maxDate,
        onChange: this.handleChange,
        language: intl.locale,
        twoStepChange: false
      })), _react.default.createElement(_Dialog.DialogActions, null, _react.default.createElement(_Button.default, {
        variant: "outlined",
        onClick: this.handleCancelClick
      }, cancelButton), _react.default.createElement(_Button.default, {
        onClick: this.handleConfirmationClick
      }, confirmButton))));
    }
  }]);
  return DateRangeInput;
}(_react.Component);

DateRangeInput.propTypes = process.env.NODE_ENV !== "production" ? {
  cancelButton: _propTypes.default.node,
  classes: _propTypes.default.object.isRequired,
  confirmButton: _propTypes.default.node,
  dateRangeMessageId: _propTypes.default.string,
  disabled: _propTypes.default.bool,
  intl: _propTypes.default.object.isRequired,
  label: _propTypes.default.node.isRequired,
  maxDate: _propTypes.default.instanceOf(Date),
  minDate: _propTypes.default.instanceOf(Date),
  onBlur: _propTypes.default.func,
  onChange: _propTypes.default.func.isRequired,
  value: _propTypes.default.oneOfType([_propTypes.default.object, _propTypes.default.string]).isRequired
} : {};
DateRangeInput.defaultProps = {
  confirmButton: 'Ok',
  cancelButton: 'Cancel'
};

var _default = (0, _reactIntl.injectIntl)((0, _styles.withStyles)(styles)(DateRangeInput));

exports.default = _default;