"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/builtin/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/builtin/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/builtin/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/builtin/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/builtin/possibleConstructorReturn"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/builtin/inherits"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _reactDateRange = require("@moblee/react-date-range");

var _moment = _interopRequireDefault(require("moment"));

var _withTheme = _interopRequireDefault(require("../styles/withTheme"));

var _getCalendarTheme = _interopRequireDefault(require("../styles/getCalendarTheme"));

var DateRangePicker =
/*#__PURE__*/
function (_Component) {
  (0, _inherits2.default)(DateRangePicker, _Component);

  function DateRangePicker() {
    var _ref;

    var _temp, _this;

    (0, _classCallCheck2.default)(this, DateRangePicker);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return (0, _possibleConstructorReturn2.default)(_this, (_temp = _this = (0, _possibleConstructorReturn2.default)(this, (_ref = DateRangePicker.__proto__ || Object.getPrototypeOf(DateRangePicker)).call.apply(_ref, [this].concat(args))), _this.handleChange = function (range) {
      var onChange = _this.props.onChange;

      if (onChange) {
        onChange({
          start: range.startDate.toDate(),
          end: range.endDate.toDate()
        });
      }
    }, _temp));
  }

  (0, _createClass2.default)(DateRangePicker, [{
    key: "render",
    value: function render() {
      var _props = this.props,
          className = _props.className,
          style = _props.style,
          theme = _props.theme,
          startDate = _props.startDate,
          endDate = _props.endDate,
          minDate = _props.minDate,
          maxDate = _props.maxDate,
          calendars = _props.calendars,
          language = _props.language,
          twoStepChange = _props.twoStepChange;
      return _react.default.createElement(_reactDateRange.DateRange, {
        startDate: startDate && (0, _moment.default)(startDate),
        endDate: endDate && (0, _moment.default)(endDate),
        theme: (0, _getCalendarTheme.default)(theme),
        className: className,
        style: style,
        onChange: this.handleChange,
        minDate: minDate && (0, _moment.default)(minDate),
        maxDate: maxDate && (0, _moment.default)(maxDate),
        calendars: calendars,
        lang: language,
        linkedCalendars: true,
        twoStepChange: twoStepChange
      });
    }
  }]);
  return DateRangePicker;
}(_react.Component);

DateRangePicker.propTypes = process.env.NODE_ENV !== "production" ? {
  calendars: _propTypes.default.number,
  className: _propTypes.default.string,
  endDate: _propTypes.default.instanceOf(Date),
  language: _propTypes.default.string,
  maxDate: _propTypes.default.instanceOf(Date),
  minDate: _propTypes.default.instanceOf(Date),
  onChange: _propTypes.default.func,
  startDate: _propTypes.default.instanceOf(Date),
  style: _propTypes.default.object,
  theme: _propTypes.default.object.isRequired,
  twoStepChange: _propTypes.default.bool
} : {};
DateRangePicker.defaultProps = {
  calendars: 2,
  twoStepChange: true
};

var _default = (0, _withTheme.default)()(DateRangePicker);

exports.default = _default;