"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/builtin/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _withStyles = _interopRequireDefault(require("../styles/withStyles"));

var styles = function styles(theme) {
  return {
    root: {
      display: 'block',
      width: '100%',
      '&:not(:last-child)': {
        marginBottom: theme.spacing.medium
      }
    }
  };
};

function DialogContentImage(_ref) {
  var className = _ref.className,
      style = _ref.style,
      classes = _ref.classes,
      src = _ref.src,
      alt = _ref.alt;
  return _react.default.createElement("img", {
    className: (0, _classnames.default)(classes.root, className),
    style: style,
    src: src,
    alt: alt
  });
}

DialogContentImage.propTypes = process.env.NODE_ENV !== "production" ? {
  alt: _propTypes.default.string.isRequired,
  classes: _propTypes.default.object.isRequired,
  className: _propTypes.default.string,
  src: _propTypes.default.string.isRequired,
  style: _propTypes.default.object
} : {};
DialogContentImage.defaultProps = {
  style: null,
  className: null
};

var _default = (0, _withStyles.default)(styles)(DialogContentImage);

exports.default = _default;