"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/builtin/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/builtin/defineProperty"));

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _withStyles = _interopRequireDefault(require("../styles/withStyles"));

var _Typography = _interopRequireDefault(require("../Typography"));

var _Tooltip = _interopRequireDefault(require("../Tooltip"));

var styles = function styles(theme) {
  return {
    root: (0, _defineProperty2.default)({
      width: theme.spacing.small,
      display: 'flex',
      justifyContent: 'center',
      position: 'relative',
      zIndex: 1
    }, theme.breakpoints.down('sm'), {
      width: theme.spacing.unit
    }),
    wrapper: (0, _defineProperty2.default)({
      position: 'absolute',
      width: 15 * theme.spacing.unit,
      pointerEvents: 'none',
      bottom: 38
    }, theme.breakpoints.down('sm'), {
      bottom: 31
    }),
    arrow: {
      display: 'flex',
      justifyContent: 'center'
    },
    arrowBody: (0, _defineProperty2.default)({
      width: 'auto',
      minWidth: 40,
      backgroundColor: theme.palette.common.dark,
      zIndex: 1,
      pointerEvents: 'auto'
    }, theme.breakpoints.down('sm'), {
      minWidth: 30
    }),
    arrowTip: (0, _defineProperty2.default)({
      height: '100%',
      fill: theme.palette.common.dark
    }, theme.breakpoints.down('sm'), {
      width: 7.2
    }),
    arrowTipPath: {
      pointerEvents: 'fill'
    },
    label: (0, _defineProperty2.default)({
      cursor: 'default',
      color: theme.palette.common.white,
      margin: [[10, -4, 9, 4]],
      textAlign: 'center',
      lineHeight: 1,
      WebkitFontSmoothing: 'antialiased',
      fontWeight: 600,
      fontSize: theme.typography.pxToRem(21)
    }, theme.breakpoints.down('sm'), {
      fontSize: theme.typography.pxToRem(14),
      margin: '5px -2px 5px 2px'
    })
  };
};

function FunnelConversion(_ref) {
  var classes = _ref.classes,
      label = _ref.label,
      tooltip = _ref.tooltip;
  return _react.default.createElement("div", {
    className: classes.root
  }, _react.default.createElement("div", {
    className: classes.wrapper
  }, _react.default.createElement(_Tooltip.default, {
    title: tooltip,
    placement: "top"
  }, _react.default.createElement("div", {
    className: classes.arrow
  }, _react.default.createElement("div", {
    className: classes.arrowBody
  }, _react.default.createElement(_Typography.default, {
    className: classes.label,
    variant: "title"
  }, label)), _react.default.createElement("svg", {
    className: classes.arrowTip,
    width: 12,
    height: 40,
    viewBox: "0 0 12 40"
  }, _react.default.createElement("path", {
    className: classes.arrowTipPath,
    d: "M0,40V0L12,20Z"
  }))))));
}

FunnelConversion.propTypes = process.env.NODE_ENV !== "production" ? {
  classes: _propTypes.default.object.isRequired,
  label: _propTypes.default.node.isRequired,
  tooltip: _propTypes.default.string
} : {};

var _default = (0, _withStyles.default)(styles)(FunnelConversion);

exports.default = _default;