"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/builtin/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/builtin/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/builtin/extends"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/builtin/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/builtin/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/builtin/possibleConstructorReturn"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/builtin/inherits"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/builtin/defineProperty"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _withStyles = _interopRequireDefault(require("../styles/withStyles"));

var _Typography = _interopRequireDefault(require("../Typography"));

var _CircularProgress = _interopRequireDefault(require("../CircularProgress"));

var ENTER_KEY = 13;
var SPACE_KEY = 32;

var styles = function styles(theme) {
  var _caption;

  return {
    root: {
      display: 'flex',
      flexDirection: 'column',
      position: 'relative',
      backgroundColor: 'transparent',
      flex: '1 1 0',
      marginBottom: -1,
      border: [1, 'solid', 'transparent'],
      transition: ['borderColor', "".concat(theme.transitions.duration.shorter, "ms")]
    },
    rootSelected: {
      border: theme.borders[1],
      boxShadow: theme.shadows[1],
      borderBottom: 'none',
      '& $indicator': {
        display: 'block'
      },
      '& $content': (0, _defineProperty2.default)({
        paddingBottom: theme.spacing.small,
        marginBottom: 0,
        cursor: 'default',
        backgroundColor: theme.palette.common.white,
        '&:hover': {
          backgroundColor: theme.palette.common.white
        },
        '&:focus': {
          backgroundColor: theme.palette.common.white
        }
      }, theme.breakpoints.down('sm'), {
        paddingBottom: theme.spacing.xsmall
      }),
      '& $progress': {
        opacity: 1
      }
    },
    indicator: {
      height: 4,
      backgroundColor: theme.palette.primary.main,
      position: 'absolute',
      top: -1,
      left: -1,
      right: -1,
      display: 'none'
    },
    content: (0, _defineProperty2.default)({
      display: 'flex',
      justifyContent: 'space-between',
      flexDirection: 'column',
      alignItems: 'center',
      flexGrow: 1,
      paddingTop: theme.spacing.small,
      marginBottom: theme.spacing.small,
      backgroundColor: theme.palette.common.lightest,
      cursor: 'pointer',
      WebkitTapHighlightColor: 'rgba(0, 0, 0, 0)',
      transition: [['background-color', "".concat(theme.transitions.duration.short, "ms")], ['border-color', "".concat(theme.transitions.duration.short, "ms")]],
      borderBottom: '3px solid transparent',
      outline: 'none',
      '&:hover': {
        backgroundColor: theme.palette.common.light
      },
      '&:focus': {
        backgroundColor: theme.palette.common.light
      }
    }, theme.breakpoints.down('sm'), {
      paddingLeft: theme.spacing.xsmall,
      paddingRight: theme.spacing.xsmall,
      marginBottom: theme.spacing.xsmall
    }),
    title: (0, _defineProperty2.default)({
      lineHeight: 1.1
    }, theme.breakpoints.down('sm'), {
      fontSize: theme.typography.pxToRem(14)
    }),
    progress: (0, _defineProperty2.default)({
      opacity: 0.7,
      margin: [[theme.spacing.medium, 0]]
    }, theme.breakpoints.down('sm'), {
      margin: [[theme.spacing.small, 0]]
    }),
    detail: (0, _defineProperty2.default)({
      marginTop: theme.spacing.small,
      marginBottom: theme.spacing.small
    }, theme.breakpoints.down('sm'), {
      fontSize: theme.typography.pxToRem(24),
      marginTop: theme.spacing.xsmall
    }),
    caption: (_caption = {
      lineHeight: 1.1,
      width: '100%',
      padding: [[0, theme.spacing.xsmall]],
      boxSizing: 'border-box',
      textAlign: 'center',
      position: 'absolute',
      bottom: 0,
      opacity: 0,
      transform: 'translate3d(0, -4px, 0)',
      transition: "\n      opacity ".concat(theme.transitions.duration.standard, "ms,\n      transform ").concat(theme.transitions.duration.standard, "ms\n    ")
    }, (0, _defineProperty2.default)(_caption, theme.breakpoints.down('sm'), {
      fontSize: theme.typography.pxToRem(12)
    }), (0, _defineProperty2.default)(_caption, "pointerEvents", 'none'), _caption),
    captionVisible: {
      opacity: 1,
      transform: 'translate3d(0, 0, 0)'
    },
    captionPositive: {
      color: theme.palette.success.light
    },
    captionNegative: {
      color: theme.palette.error.light
    }
  };
};

var FunnelTab =
/*#__PURE__*/
function (_Component) {
  (0, _inherits2.default)(FunnelTab, _Component);

  function FunnelTab() {
    var _ref;

    var _temp, _this;

    (0, _classCallCheck2.default)(this, FunnelTab);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return (0, _possibleConstructorReturn2.default)(_this, (_temp = _this = (0, _possibleConstructorReturn2.default)(this, (_ref = FunnelTab.__proto__ || Object.getPrototypeOf(FunnelTab)).call.apply(_ref, [this].concat(args))), _this.onKeyDown = function (event) {
      if (event.keyCode === ENTER_KEY || event.keyCode === SPACE_KEY) {
        _this.props.onClick();
      }
    }, _this.onClick = function () {
      return _this.props.onClick();
    }, _this.getTabClickableProps = function () {
      return !_this.props.selected && {
        role: 'tab',
        tabIndex: 0,
        onKeyDown: _this.onKeyDown,
        onClick: _this.onClick
      };
    }, _temp));
  }

  (0, _createClass2.default)(FunnelTab, [{
    key: "getWarningClassNames",
    value: function getWarningClassNames() {
      var _props = this.props,
          classes = _props.classes,
          captionType = _props.captionType,
          selected = _props.selected;
      return (0, _classnames.default)(classes.caption, selected && classes.captionVisible, captionType === 'positive' && classes.captionPositive, captionType === 'negative' && classes.captionNegative);
    }
  }, {
    key: "render",
    value: function render() {
      var _props2 = this.props,
          classes = _props2.classes,
          className = _props2.className,
          title = _props2.title,
          detail = _props2.detail,
          caption = _props2.caption,
          selected = _props2.selected,
          loading = _props2.loading;
      return _react.default.createElement("div", {
        className: (0, _classnames.default)(classes.root, className, selected && classes.rootSelected)
      }, _react.default.createElement("div", {
        className: classes.indicator
      }), _react.default.createElement("div", (0, _extends2.default)({}, this.getTabClickableProps(), {
        className: classes.content
      }), _react.default.createElement(_Typography.default, {
        align: "center",
        className: classes.title,
        variant: "subheading"
      }, title), loading ? _react.default.createElement(_CircularProgress.default, {
        className: classes.progress,
        color: "grey",
        size: 32
      }) : _react.default.createElement(_Typography.default, {
        align: "center",
        className: classes.detail,
        variant: "display1"
      }, detail)), _react.default.createElement(_Typography.default, {
        align: "center",
        className: this.getWarningClassNames(),
        variant: "subheading"
      }, caption));
    }
  }]);
  return FunnelTab;
}(_react.Component);

FunnelTab.defaultProps = {
  selected: false,
  loading: false
};
FunnelTab.propTypes = process.env.NODE_ENV !== "production" ? {
  caption: _propTypes.default.string,
  captionType: _propTypes.default.string,
  classes: _propTypes.default.object.isRequired,
  className: _propTypes.default.string,
  detail: _propTypes.default.string.isRequired,
  loading: _propTypes.default.bool,
  onClick: _propTypes.default.func.isRequired,
  selected: _propTypes.default.bool,
  title: _propTypes.default.string.isRequired
} : {};

var _default = (0, _withStyles.default)(styles)(FunnelTab);

exports.default = _default;