"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/builtin/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/builtin/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/builtin/objectWithoutProperties"));

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _Link = _interopRequireDefault(require("react-router-dom/Link"));

var _withStyles = _interopRequireDefault(require("../styles/withStyles"));

var styles = function styles(theme) {
  return {
    root: {
      color: theme.palette.primary.main,
      textDecoration: 'none',
      transition: "color ".concat(theme.transitions.duration.short, "ms"),
      '&:visited': {
        color: theme.palette.primary.main
      },
      '&:hover': {
        color: theme.palette.primary.dark
      },
      '&:active': {
        color: theme.palette.primary.dark
      }
    },
    link: {
      background: 'none',
      border: 'none',
      padding: 0,
      margin: 0,
      fontSize: 'inherit',
      lineHeight: 'inherit',
      fontWeight: 'inherit',
      cursor: 'pointer'
    }
  };
};

function Link(_ref) {
  var children = _ref.children,
      classes = _ref.classes,
      className = _ref.className,
      external = _ref.external,
      title = _ref.title,
      to = _ref.to,
      props = (0, _objectWithoutProperties2.default)(_ref, ["children", "classes", "className", "external", "title", "to"]);

  if (typeof to === 'undefined') {
    return _react.default.createElement("button", (0, _extends2.default)({
      className: (0, _classnames.default)(classes.root, classes.link, className),
      type: "button"
    }, props), children);
  }

  if (external) {
    return _react.default.createElement("a", (0, _extends2.default)({
      target: "_blank",
      href: to,
      title: title,
      className: (0, _classnames.default)(classes.root, className)
    }, props), children);
  }

  return _react.default.createElement(_Link.default, (0, _extends2.default)({
    to: to,
    title: title,
    className: (0, _classnames.default)(classes.root, className)
  }, props), children);
}

Link.propTypes = process.env.NODE_ENV !== "production" ? {
  children: _propTypes.default.node,
  classes: _propTypes.default.object.isRequired,
  className: _propTypes.default.string,
  external: _propTypes.default.bool,
  title: _propTypes.default.string,
  to: _propTypes.default.string
} : {};
Link.defaultProps = {
  external: false
};

var _default = (0, _withStyles.default)(styles)(Link);

exports.default = _default;