"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/builtin/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime/helpers/builtin/toConsumableArray"));

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _FormControl = _interopRequireDefault(require("../FormControl"));

var _Checkbox = _interopRequireDefault(require("../Checkbox"));

var _FormControlLabel = _interopRequireDefault(require("../FormControlLabel"));

var _InputLabel = _interopRequireDefault(require("../InputLabel"));

var _FormHelperText = _interopRequireDefault(require("../FormHelperText"));

var _withStyles = _interopRequireDefault(require("../styles/withStyles"));

function isChecked(option, value) {
  return value.includes(option);
}

function getOnChange(option, inputValue, onChange) {
  return function (event) {
    if (event.target.checked) {
      onChange((0, _toConsumableArray2.default)(inputValue).concat([option]));
    } else {
      onChange(inputValue.filter(function (entry) {
        return entry !== option;
      }));
    }
  };
}

function MultiCheckboxInput(_ref) {
  var classes = _ref.classes,
      className = _ref.className,
      disabled = _ref.disabled,
      helperText = _ref.helperText,
      error = _ref.error,
      fullWidth = _ref.fullWidth,
      label = _ref.label,
      margin = _ref.margin,
      required = _ref.required,
      options = _ref.options,
      value = _ref.value,
      onChange = _ref.onChange;
  return _react.default.createElement(_FormControl.default, {
    className: className,
    disabled: disabled,
    error: error,
    fullWidth: fullWidth,
    margin: margin,
    required: required
  }, label && _react.default.createElement(_InputLabel.default, null, label), options.map(function (option) {
    var checked = isChecked(option.value, value);
    return _react.default.createElement(_FormControlLabel.default, {
      key: option.value,
      className: classes.formControlLabel,
      label: option.label,
      control: _react.default.createElement(_Checkbox.default, {
        checked: checked,
        onChange: getOnChange(option.value, value, onChange),
        value: option.value
      })
    });
  }), helperText && _react.default.createElement(_FormHelperText.default, null, helperText));
}

MultiCheckboxInput.propTypes = process.env.NODE_ENV !== "production" ? {
  classes: _propTypes.default.object.isRequired,
  className: _propTypes.default.string,
  disabled: _propTypes.default.bool,
  error: _propTypes.default.bool,
  fullWidth: _propTypes.default.bool,
  helperText: _propTypes.default.node,
  label: _propTypes.default.node,
  margin: _propTypes.default.oneOf(['none', 'dense', 'normal']),
  onChange: _propTypes.default.func.isRequired,
  options: _propTypes.default.array.isRequired,
  required: _propTypes.default.bool,
  value: _propTypes.default.array
} : {};
MultiCheckboxInput.defaultProps = {
  disabled: false,
  error: false,
  fullWidth: false,
  margin: 'none',
  required: false,
  className: undefined,
  helperText: undefined,
  label: undefined,
  value: []
};
var styles = {
  formControlLabel: {
    marginRight: 0
  }
};

var _default = (0, _withStyles.default)(styles)(MultiCheckboxInput);

exports.default = _default;