"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/builtin/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/builtin/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/builtin/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/builtin/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/builtin/possibleConstructorReturn"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/builtin/inherits"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _styles = require("../styles");

var _CircularProgress = _interopRequireDefault(require("../CircularProgress"));

var _Search = _interopRequireDefault(require("../icons/Search"));

var _Cancel = _interopRequireDefault(require("../icons/Cancel"));

var _Input = _interopRequireDefault(require("../Input"));

var _IconButton = _interopRequireDefault(require("../IconButton"));

var styles = function styles(theme) {
  return {
    root: {
      display: 'inline-flex',
      alignItems: 'center',
      position: 'relative'
    },
    searchIcon: {
      position: 'absolute',
      left: theme.spacing.unit,
      color: theme.palette.text.primary
    },
    cancelButtom: {
      width: 32,
      height: 32,
      position: 'absolute',
      right: 0,
      transition: theme.transitions.create(['opacity', 'transform'], {
        duration: theme.transitions.duration.shortest,
        easing: theme.transitions.easing.sharp
      })
    },
    cancelButtomHidden: {
      transform: 'scale(.25)',
      opacity: 0
    },
    cancelIcon: {
      width: theme.spacing.small,
      height: theme.spacing.small
    },
    inputRoot: {
      width: '100%',
      fontSize: 'inherit'
    },
    inputInput: {
      boxSizing: 'border-box',
      height: 40,
      paddingRight: theme.spacing.large,
      paddingLeft: theme.spacing.large
    }
  };
};

var SearchInput =
/*#__PURE__*/
function (_Component) {
  (0, _inherits2.default)(SearchInput, _Component);

  function SearchInput() {
    var _ref;

    var _temp, _this;

    (0, _classCallCheck2.default)(this, SearchInput);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return (0, _possibleConstructorReturn2.default)(_this, (_temp = _this = (0, _possibleConstructorReturn2.default)(this, (_ref = SearchInput.__proto__ || Object.getPrototypeOf(SearchInput)).call.apply(_ref, [this].concat(args))), _this.state = {
      query: ''
    }, _this.handleInputChange = function (event) {
      return _this.setQuery(event.target.value);
    }, _this.handleCancelClick = function () {
      return _this.setQuery('', true);
    }, _temp));
  }

  (0, _createClass2.default)(SearchInput, [{
    key: "setQuery",
    value: function setQuery(query, force) {
      var _this2 = this;

      this.setState({
        query: query
      });

      if (this.props.throttle && !force) {
        clearTimeout(this.searchTimeout);
        this.searchTimeout = setTimeout(function () {
          _this2.props.onChange(query);
        }, 500);
      } else {
        this.props.onChange(query);
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _props = this.props,
          classes = _props.classes,
          className = _props.className,
          loading = _props.loading,
          value = _props.value,
          inputRef = _props.inputRef;
      var query = this.state.query;
      return _react.default.createElement("div", {
        className: (0, _classnames.default)(className, classes.root)
      }, loading ? _react.default.createElement(_CircularProgress.default, {
        className: classes.searchIcon,
        size: 24
      }) : _react.default.createElement(_Search.default, {
        className: classes.searchIcon
      }), _react.default.createElement(_Input.default, {
        inputRef: inputRef,
        onChange: this.handleInputChange,
        value: value || query,
        classes: {
          root: classes.inputRoot,
          input: classes.inputInput
        }
      }), _react.default.createElement(_IconButton.default, {
        className: (0, _classnames.default)(classes.cancelButtom, !query && classes.cancelButtomHidden),
        disabled: !query,
        onClick: this.handleCancelClick
      }, _react.default.createElement(_Cancel.default, {
        className: classes.cancelIcon
      })));
    }
  }]);
  return SearchInput;
}(_react.Component);

SearchInput.propTypes = process.env.NODE_ENV !== "production" ? {
  classes: _propTypes.default.object.isRequired,
  className: _propTypes.default.string,
  inputRef: _propTypes.default.func,
  loading: _propTypes.default.bool,
  onChange: _propTypes.default.func.isRequired,
  throttle: _propTypes.default.bool,
  value: _propTypes.default.string
} : {};
SearchInput.defaultProps = {
  loading: false,
  throttle: false
};

var _default = (0, _styles.withStyles)(styles)(SearchInput);

exports.default = _default;