"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/builtin/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/builtin/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/builtin/objectWithoutProperties"));

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _withStyles = _interopRequireDefault(require("../styles/withStyles"));

var _ListItem = _interopRequireDefault(require("../ListItem"));

var _ListItemIcon = _interopRequireDefault(require("../ListItemIcon"));

var _Typography = _interopRequireDefault(require("../Typography"));

var styles = function styles(theme) {
  return {
    root: {
      '&.active': {
        cursor: 'default',
        backgroundColor: theme.palette.common.lightest,
        '& > *': {
          color: theme.palette.secondary.main
        }
      }
    },
    primary: {
      '& $text': {
        textTransform: 'uppercase',
        fontWeight: 'bold'
      },
      '$secondary + &': {
        marginTop: theme.spacing.medium
      }
    },
    secondary: {
      paddingLeft: 6 * theme.spacing.unit
    },
    icon: {
      marginRight: theme.spacing.xsmall
    },
    text: {
      flex: [[1, 1, 0]],
      padding: 0
    }
  };
};

function SideMenuItem(_ref) {
  var className = _ref.className,
      classes = _ref.classes,
      label = _ref.label,
      icon = _ref.icon,
      selected = _ref.selected,
      other = (0, _objectWithoutProperties2.default)(_ref, ["className", "classes", "label", "icon", "selected"]);
  var rootClasses = (0, _classnames.default)(classes.root, icon ? classes.primary : classes.secondary, selected && 'active', className);
  return _react.default.createElement(_ListItem.default, (0, _extends2.default)({
    className: rootClasses
  }, other, {
    button: true,
    disableRipple: true
  }), Boolean(icon) && _react.default.createElement(_ListItemIcon.default, {
    className: classes.icon
  }, icon), _react.default.createElement(_Typography.default, {
    className: classes.text
  }, label));
}

SideMenuItem.propTypes = process.env.NODE_ENV !== "production" ? {
  classes: _propTypes.default.object.isRequired,
  className: _propTypes.default.string,
  icon: _propTypes.default.element,
  label: _propTypes.default.node.isRequired,
  selected: _propTypes.default.bool
} : {};
SideMenuItem.defaultProps = {
  selected: false
};

var _default = (0, _withStyles.default)(styles)(SideMenuItem);

exports.default = _default;