"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/builtin/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/builtin/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/builtin/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/builtin/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/builtin/possibleConstructorReturn"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/builtin/inherits"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _withStyles = _interopRequireDefault(require("../styles/withStyles"));

var _IconButton = _interopRequireDefault(require("../IconButton"));

var styles = function styles(theme) {
  return {
    root: {
      display: 'flex',
      alignItems: 'center',
      minWidth: 167,
      minHeight: 36
    },
    handle: {
      position: 'relative',
      flex: 1,
      alignSelf: 'stretch',
      cursor: 'pointer',
      '&:focus': {
        outline: 'none'
      }
    },
    track: {
      position: 'absolute',
      top: '50%',
      width: '100%',
      height: 2,
      transform: 'translate3d(0, -50%, 0)',
      backgroundColor: theme.palette.common.lightBlack
    },
    trackFill: {
      height: '100%',
      backgroundColor: theme.palette.primary.main
    },
    thumb: {
      position: 'absolute',
      top: '50%',
      width: 36,
      height: 36,
      transform: 'translate3d(-50%, -50%, 0)'
    },
    thumbIndicator: {
      position: 'absolute',
      top: '50%',
      left: '50%',
      width: 12,
      height: 12,
      transform: 'translate3d(-50%, -50%, 0)',
      backgroundColor: theme.palette.primary.main,
      borderRadius: '50%',
      transition: "transform ".concat(theme.transitions.duration.short, "ms")
    },
    thumbIndicatorBig: {
      transform: ['translate3d(-50%, -50%, 0)', 'scale(1.5)']
    },
    rippleWrapper: {
      position: 'absolute',
      top: 0,
      left: 0,
      width: '100%',
      height: '100%',
      animation: "ripple-in ".concat(theme.transitions.duration.short, "ms ").concat(theme.transitions.easing.easeInOut)
    },
    '@keyframes ripple-in': {
      from: {
        transform: 'scale(0)'
      },
      to: {
        transform: 'scale(1)'
      }
    },
    ripple: {
      position: 'absolute',
      top: 0,
      left: 0,
      width: '100%',
      height: '100%',
      borderRadius: '50%',
      animation: "ripple-pulse 1500ms ".concat(theme.transitions.easing.easeInOut, " infinite"),
      backgroundColor: theme.palette.common.faintBlack
    },
    '@keyframes ripple-pulse': {
      '0%': {
        transform: 'scale(0.9)'
      },
      '50%': {
        transform: 'scale(1)'
      },
      '100%': {
        transform: 'scale(0.9)'
      }
    }
  };
};

var Slider =
/*#__PURE__*/
function (_Component) {
  (0, _inherits2.default)(Slider, _Component);

  function Slider() {
    var _ref;

    var _temp, _this;

    (0, _classCallCheck2.default)(this, Slider);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return (0, _possibleConstructorReturn2.default)(_this, (_temp = _this = (0, _possibleConstructorReturn2.default)(this, (_ref = Slider.__proto__ || Object.getPrototypeOf(Slider)).call.apply(_ref, [this].concat(args))), _this.state = {
      dragging: false
    }, _this.handleMouseDown = function (event) {
      _this.setState({
        dragging: true
      });

      _this.handleMouseMove(event);

      document.addEventListener('mousemove', _this.handleMouseMove);
      document.addEventListener('mouseup', _this.handleMouseUp);
    }, _this.handleMouseMove = function (event) {
      var onChange = _this.props.onChange;

      var boudingRect = _this.track.getBoundingClientRect();

      var position = event.clientX - boudingRect.left;
      var ratio = position / boudingRect.width;
      onChange(_this.ratioToValue(ratio));
    }, _this.handleMouseUp = function () {
      _this.setState({
        dragging: false
      });

      document.removeEventListener('mousemove', _this.handleMouseMove);
      document.removeEventListener('mouseup', _this.handleMouseUp);
    }, _this.handleZoom = function (step) {
      return function () {
        var onChange = _this.props.onChange;

        var ratio = _this.valueToRatio();

        onChange(_this.ratioToValue(ratio + step));
      };
    }, _temp));
  }

  (0, _createClass2.default)(Slider, [{
    key: "valueToRatio",
    value: function valueToRatio() {
      var _props = this.props,
          min = _props.min,
          max = _props.max,
          value = _props.value;
      return (value - min) / (max - min);
    }
  }, {
    key: "ratioToValue",
    value: function ratioToValue(ratio) {
      var _props2 = this.props,
          min = _props2.min,
          max = _props2.max;
      var roundedRatio = 0.001 * Math.round(ratio * 1000);
      return Math.min(max, Math.max(min, (max - min) * roundedRatio + min));
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      var dragging = this.state.dragging;
      var _props3 = this.props,
          classes = _props3.classes,
          className = _props3.className,
          style = _props3.style,
          min = _props3.min,
          max = _props3.max,
          value = _props3.value,
          fromIcon = _props3.fromIcon,
          toIcon = _props3.toIcon;
      var percentage = 100 * (value - min) / (max - min);
      return _react.default.createElement("div", {
        className: (0, _classnames.default)(classes.root, className),
        style: style
      }, fromIcon && _react.default.createElement(_IconButton.default, {
        onClick: this.handleZoom(-0.1)
      }, fromIcon), _react.default.createElement("div", {
        ref: function ref(el) {
          _this2.track = el;
        },
        className: classes.handle,
        onMouseDown: this.handleMouseDown,
        tabIndex: 0,
        role: "slider",
        "aria-valuemax": max,
        "aria-valuemin": min,
        "aria-valuenow": value
      }, _react.default.createElement("div", {
        className: classes.track
      }, _react.default.createElement("div", {
        className: classes.trackFill,
        style: {
          width: "".concat(percentage, "%")
        }
      })), _react.default.createElement("div", {
        className: classes.thumb,
        style: {
          left: "".concat(percentage, "%")
        }
      }, dragging && _react.default.createElement("div", {
        className: classes.rippleWrapper
      }, _react.default.createElement("div", {
        className: classes.ripple
      })), _react.default.createElement("div", {
        className: (0, _classnames.default)(classes.thumbIndicator, dragging && classes.thumbIndicatorBig)
      }))), toIcon && _react.default.createElement(_IconButton.default, {
        onClick: this.handleZoom(0.1)
      }, toIcon));
    }
  }]);
  return Slider;
}(_react.Component);

Slider.propTypes = process.env.NODE_ENV !== "production" ? {
  classes: _propTypes.default.object.isRequired,
  className: _propTypes.default.string,
  fromIcon: _propTypes.default.element,
  max: _propTypes.default.number,
  min: _propTypes.default.number,
  onChange: _propTypes.default.func.isRequired,
  style: _propTypes.default.object,
  toIcon: _propTypes.default.element,
  value: _propTypes.default.number
} : {};
Slider.defaultProps = {
  max: 100,
  min: 0,
  value: 50
};

var _default = (0, _withStyles.default)(styles)(Slider);

exports.default = _default;