"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/builtin/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/builtin/extends"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/builtin/defineProperty"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/builtin/objectWithoutProperties"));

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _withStyles = _interopRequireDefault(require("../styles/withStyles"));

var _FormControlLabel = _interopRequireDefault(require("../FormControlLabel"));

var _FormControl = _interopRequireDefault(require("../FormControl"));

var _InputLabel = _interopRequireDefault(require("../InputLabel"));

var _Switch = _interopRequireDefault(require("../Switch"));

var _FormHelperText = _interopRequireDefault(require("../FormHelperText"));

var styles = function styles(theme) {
  return {
    formControlLabel: {
      marginLeft: 0,
      marginRight: -6
    },
    formControlLabelReversed: {
      flexDirection: 'row-reverse'
    },
    switchRightMargin: {
      marginRight: theme.spacing.xsmall
    }
  };
};

function SwitchInput(_ref) {
  var classes = _ref.classes,
      className = _ref.className,
      disabled = _ref.disabled,
      error = _ref.error,
      fullWidth = _ref.fullWidth,
      helperText = _ref.helperText,
      label = _ref.label,
      margin = _ref.margin,
      required = _ref.required,
      text = _ref.text,
      switchPosition = _ref.switchPosition,
      other = (0, _objectWithoutProperties2.default)(_ref, ["classes", "className", "disabled", "error", "fullWidth", "helperText", "label", "margin", "required", "text", "switchPosition"]);
  return _react.default.createElement(_FormControl.default, {
    className: className,
    disabled: disabled,
    error: error,
    fullWidth: fullWidth,
    margin: margin,
    required: required
  }, label && _react.default.createElement(_InputLabel.default, null, label), _react.default.createElement(_FormControlLabel.default, {
    className: (0, _classnames.default)(classes.formControlLabel, (0, _defineProperty2.default)({}, classes.formControlLabelReversed, switchPosition === 'right')),
    control: _react.default.createElement(_Switch.default, (0, _extends2.default)({
      className: (0, _classnames.default)((0, _defineProperty2.default)({}, classes.switchRightMargin, switchPosition === 'left'))
    }, other)),
    label: text
  }), helperText && _react.default.createElement(_FormHelperText.default, null, helperText));
}

SwitchInput.propTypes = process.env.NODE_ENV !== "production" ? {
  classes: _propTypes.default.object.isRequired,
  className: _propTypes.default.string,
  disabled: _propTypes.default.bool,
  error: _propTypes.default.bool,
  fullWidth: _propTypes.default.bool,
  helperText: _propTypes.default.node,
  label: _propTypes.default.node,
  margin: _propTypes.default.oneOf(['none', 'dense', 'normal']),
  required: _propTypes.default.bool,
  switchPosition: _propTypes.default.oneOf(['left', 'right']),
  text: _propTypes.default.node
} : {};
SwitchInput.defaultProps = {
  disabled: false,
  error: false,
  fullWidth: false,
  margin: 'none',
  required: false,
  switchPosition: 'right'
};

var _default = (0, _withStyles.default)(styles)(SwitchInput);

exports.default = _default;