"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/builtin/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.styles = void 0;

var _objectSpread2 = _interopRequireDefault(require("@babel/runtime/helpers/builtin/objectSpread"));

var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime/helpers/builtin/toConsumableArray"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/builtin/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/builtin/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/builtin/possibleConstructorReturn"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/builtin/inherits"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/builtin/defineProperty"));

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _withStyles = _interopRequireDefault(require("../styles/withStyles"));

var _MenuItem = _interopRequireDefault(require("../MenuItem"));

var _Select = _interopRequireDefault(require("../Select"));

var _Typography = _interopRequireDefault(require("../Typography"));

var _IconButton = _interopRequireDefault(require("../IconButton"));

var _NavigateNext = _interopRequireDefault(require("../icons/NavigateNext"));

var _NavigateBefore = _interopRequireDefault(require("../icons/NavigateBefore"));

var _Fade = _interopRequireDefault(require("../Fade"));

var _withWidth = _interopRequireDefault(require("../withWidth"));

var styles = function styles(theme) {
  return {
    root: (0, _defineProperty2.default)({
      display: 'grid',
      grid: "\n      \"rowsLabel rowsLabel\"\n      \"sizeSelect pager\"\n      / auto 1fr\n    ",
      gridGap: "".concat(theme.spacing.small, "px"),
      marginTop: theme.spacing.small
    }, theme.breakpoints.down('xs'), {
      grid: "\n      \"rowsLabel\" \n      \"sizeSelect\"\n      \"pager\"\n      / 1fr\n    "
    }),
    rowsLabel: {
      gridArea: 'rowsLabel'
    },
    sizeSelect: {
      gridArea: 'sizeSelect',
      display: 'flex',
      alignItems: 'center'
    },
    selectLabel: {
      marginLeft: theme.spacing.unit
    },
    pager: {
      gridArea: 'pager',
      justifySelf: 'end'
    },
    button: {
      width: 40,
      height: 40,
      fontSize: theme.typography.pxToRem(14),
      fontWeight: 'bold'
    },
    ellipsis: {
      pointerEvents: 'none'
    },
    selected: {
      position: 'relative',
      pointerEvents: 'none',
      color: theme.palette.common.black,
      '&:after': {
        content: '""',
        position: 'absolute',
        height: 2,
        backgroundColor: theme.palette.primary.main,
        width: '80%',
        bottom: 0
      }
    }
  };
};

exports.styles = styles;

var _ref2 = _react.default.createElement(_NavigateBefore.default, null);

var _ref3 = _react.default.createElement(_NavigateNext.default, null);

var TablePagination =
/*#__PURE__*/
function (_React$Component) {
  (0, _inherits2.default)(TablePagination, _React$Component);

  function TablePagination() {
    var _ref;

    var _temp, _this;

    (0, _classCallCheck2.default)(this, TablePagination);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return (0, _possibleConstructorReturn2.default)(_this, (_temp = _this = (0, _possibleConstructorReturn2.default)(this, (_ref = TablePagination.__proto__ || Object.getPrototypeOf(TablePagination)).call.apply(_ref, [this].concat(args))), _this.state = {
      lastTotalCount: 0
    }, _this.getPagesNumbers = function () {
      var _this$props$list = _this.props.list,
          totalCountProp = _this$props$list.totalCount,
          _this$props$list$page = _this$props$list.page,
          current = _this$props$list$page.current,
          size = _this$props$list$page.size;
      var pagerBaseNumber = _this.props.width === 'xs' ? 3 : 5;
      var totalCount = totalCountProp || _this.state.lastTotalCount;
      var totalPages = Math.ceil(totalCount / size);
      var currentPage = current + 1;
      var sequenceStart;
      var sequenceEnd;

      if (totalPages <= pagerBaseNumber) {
        sequenceStart = 1;
        sequenceEnd = totalPages;
      } else if (currentPage < pagerBaseNumber) {
        sequenceStart = 1;
        sequenceEnd = pagerBaseNumber;
      } else if (currentPage + pagerBaseNumber - 1 > totalPages) {
        sequenceStart = totalPages - pagerBaseNumber + 1;
        sequenceEnd = totalPages;
      } else {
        sequenceStart = currentPage - Math.ceil((pagerBaseNumber - 3) / 2);
        sequenceEnd = currentPage + Math.ceil((pagerBaseNumber - 3) / 2);
      }

      var pages = (0, _toConsumableArray2.default)(Array(sequenceEnd + 1 - sequenceStart).keys()).map(function (i) {
        return sequenceStart + i;
      });

      if (totalPages > pagerBaseNumber) {
        var pagesWithDots = [];

        if (currentPage < pagerBaseNumber) {
          pagesWithDots = (0, _toConsumableArray2.default)(pages).concat([null, totalPages]);
        } else if (currentPage + pagerBaseNumber - 1 > totalPages) {
          pagesWithDots = [1, null].concat((0, _toConsumableArray2.default)(pages));
        } else {
          pagesWithDots = [1, null].concat((0, _toConsumableArray2.default)(pages), [null, totalPages]);
        }

        return pagesWithDots;
      }

      return pages;
    }, _this.getRowsLabel = function () {
      var _this$props = _this.props,
          displayedRowsLabelCreator = _this$props.displayedRowsLabelCreator,
          page = _this$props.list.page;
      var totalCount = _this.state.lastTotalCount;
      var fromRow = totalCount === 0 ? 0 : page.current * page.size + 1;
      var toRow = Math.min(totalCount, (page.current + 1) * page.size);
      return displayedRowsLabelCreator(fromRow, toRow, totalCount);
    }, _temp));
  }

  (0, _createClass2.default)(TablePagination, [{
    key: "render",
    value: function render() {
      var _props = this.props,
          pageSizeOptions = _props.pageSizeOptions,
          classes = _props.classes,
          tableSizeLabel = _props.tableSizeLabel,
          list = _props.list;
      var page = list.page,
          totalCount = list.totalCount,
          goToPreviousPage = list.goToPreviousPage,
          goToNextPage = list.goToNextPage,
          goToPage = list.goToPage,
          setPageSize = list.setPageSize;
      var currentPage = page.current + 1;
      var totalPages = Math.ceil(totalCount / page.size);
      return _react.default.createElement(_Fade.default, {
        "in": Boolean(totalCount)
      }, _react.default.createElement("div", {
        className: classes.root
      }, _react.default.createElement(_Typography.default, {
        className: classes.rowsLabel
      }, this.getRowsLabel()), _react.default.createElement("div", {
        className: classes.sizeSelect
      }, _react.default.createElement(_Select.default, {
        value: page.size,
        onChange: function onChange(event) {
          return setPageSize(event.target.value);
        }
      }, pageSizeOptions.map(function (pageSizeOption) {
        return _react.default.createElement(_MenuItem.default, {
          key: pageSizeOption,
          value: pageSizeOption
        }, pageSizeOption);
      })), _react.default.createElement(_Typography.default, {
        className: classes.selectLabel
      }, tableSizeLabel)), _react.default.createElement("div", {
        className: classes.pager
      }, _react.default.createElement(_IconButton.default, {
        className: this.props.classes.button,
        onClick: goToPreviousPage,
        color: "primary",
        disabled: currentPage === 1 || !totalCount
      }, _ref2), this.getPagesNumbers(totalCount, page).map(function (pageNumber, current) {
        var _classNames;

        return _react.default.createElement(_IconButton.default, {
          key: pageNumber || (current === 1 ? 'ellipsis1' : 'ellipsis2'),
          className: (0, _classnames.default)(classes.button, (_classNames = {}, (0, _defineProperty2.default)(_classNames, classes.selected, currentPage === pageNumber), (0, _defineProperty2.default)(_classNames, classes.ellipsis, pageNumber === null), _classNames)),
          value: pageNumber,
          onClick: function onClick() {
            return goToPage(pageNumber - 1);
          },
          color: "primary"
        }, pageNumber || '…');
      }), _react.default.createElement(_IconButton.default, {
        className: this.props.classes.button,
        onClick: goToNextPage,
        color: "primary",
        disabled: currentPage === totalPages || !totalCount
      }, _ref3))));
    }
  }], [{
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(props, state) {
      var totalCount = props.list.totalCount;

      if (totalCount) {
        return (0, _objectSpread2.default)({}, state, {
          lastTotalCount: totalCount
        });
      }

      return null;
    }
  }]);
  return TablePagination;
}(_react.default.Component);

TablePagination.defaultProps = {
  pageSizeOptions: [10, 25, 50, 100]
};
TablePagination.propTypes = process.env.NODE_ENV !== "production" ? {
  classes: _propTypes.default.object.isRequired,
  displayedRowsLabelCreator: _propTypes.default.func.isRequired,
  list: _propTypes.default.shape({
    goToPreviousPage: _propTypes.default.func.isRequired,
    goToNextPage: _propTypes.default.func.isRequired,
    goToPage: _propTypes.default.func.isRequired,
    page: _propTypes.default.shape({
      current: _propTypes.default.number.isRequired,
      size: _propTypes.default.number.isRequired
    }),
    setPageSize: _propTypes.default.func.isRequired,
    totalCount: _propTypes.default.number.isRequired
  }).isRequired,
  pageSizeOptions: _propTypes.default.array,
  tableSizeLabel: _propTypes.default.string.isRequired,
  width: _propTypes.default.string.isRequired
} : {};

var _default = (0, _withWidth.default)()((0, _withStyles.default)(styles)(TablePagination));

exports.default = _default;