"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/builtin/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/builtin/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/builtin/objectWithoutProperties"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/builtin/defineProperty"));

var _objectSpread3 = _interopRequireDefault(require("@babel/runtime/helpers/builtin/objectSpread"));

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _withStyles = _interopRequireDefault(require("../styles/withStyles"));

var _Typography = _interopRequireDefault(require("../Typography"));

var _helpers = require("../utils/helpers");

var _createPalette = require("../styles/createPalette");

var styles = function styles(theme) {
  return (0, _objectSpread3.default)({
    root: {
      display: 'inline-block',
      padding: [[2, 6, 3]],
      borderRadius: 4,
      WebkitFontSmoothing: 'auto',
      '& + &': {
        marginLeft: theme.spacing.unit
      }
    }
  }, _createPalette.colors.reduce(function (classes, color) {
    var _theme$palette$color = theme.palette[color],
        main = _theme$palette$color.main,
        contrastText = _theme$palette$color.contrastText;
    return (0, _objectSpread3.default)({}, classes, (0, _defineProperty2.default)({}, "color".concat((0, _helpers.capitalize)(color)), {
      color: contrastText,
      backgroundColor: main
    }));
  }, {}));
};

function Tag(_ref) {
  var className = _ref.className,
      classes = _ref.classes,
      color = _ref.color,
      other = (0, _objectWithoutProperties2.default)(_ref, ["className", "classes", "color"]);
  return _react.default.createElement(_Typography.default, (0, _extends2.default)({
    variant: "caption",
    color: "inherit",
    className: (0, _classnames.default)(classes.root, classes["color".concat((0, _helpers.capitalize)(color))], className)
  }, other));
}

Tag.propTypes = process.env.NODE_ENV !== "production" ? {
  classes: _propTypes.default.object.isRequired,
  className: _propTypes.default.string,
  color: _propTypes.default.oneOf(_createPalette.colors)
} : {};
Tag.defaultProps = {
  color: 'primary'
};

var _default = (0, _withStyles.default)(styles)(Tag);

exports.default = _default;