"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/builtin/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.styles = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/builtin/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/builtin/objectWithoutProperties"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/builtin/defineProperty"));

var _objectSpread2 = _interopRequireDefault(require("@babel/runtime/helpers/builtin/objectSpread"));

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _withStyles = _interopRequireDefault(require("../styles/withStyles"));

var styles = function styles(theme) {
  return {
    root: (0, _objectSpread2.default)({}, theme.mixins.toolbar, {
      position: 'relative',
      display: 'flex',
      alignItems: 'center'
    }),
    gutters: theme.mixins.gutters(),
    sticky: {
      position: 'sticky',
      top: 0,
      background: theme.palette.common.white,
      borderBottom: theme.borders[1],
      boxShadow: theme.shadows[1],
      zIndex: 1
    },
    withMargin: (0, _defineProperty2.default)({
      marginBottom: theme.spacing.medium
    }, theme.breakpoints.down('sm'), {
      marginBottom: theme.spacing.small
    })
  };
};

exports.styles = styles;

function Toolbar(props) {
  var _classNames;

  var children = props.children,
      classes = props.classes,
      classNameProp = props.className,
      disableGutters = props.disableGutters,
      sticky = props.sticky,
      withMargin = props.withMargin,
      other = (0, _objectWithoutProperties2.default)(props, ["children", "classes", "className", "disableGutters", "sticky", "withMargin"]);
  var className = (0, _classnames.default)(classes.root, (_classNames = {}, (0, _defineProperty2.default)(_classNames, classes.gutters, !disableGutters), (0, _defineProperty2.default)(_classNames, classes.sticky, sticky), (0, _defineProperty2.default)(_classNames, classes.withMargin, withMargin), _classNames), classNameProp);
  return _react.default.createElement("div", (0, _extends2.default)({
    className: className
  }, other), children);
}

Toolbar.propTypes = process.env.NODE_ENV !== "production" ? {
  /**
   * Toolbar children, usually a mixture of `IconButton`, `Button` and `Typography`.
   */
  children: _propTypes.default.node,

  /**
   * Override or extend the styles applied to the component.
   * See [CSS API](#css-api) below for more details.
   */
  classes: _propTypes.default.object.isRequired,

  /**
   * @ignore
   */
  className: _propTypes.default.string,

  /**
   * If `true`, disables gutter padding.
   */
  disableGutters: _propTypes.default.bool,

  /**
   * If `true`, sticks to the top on scroll.
   */
  sticky: _propTypes.default.bool,

  /**
   * If `true`, adds a bottom margin.
   */
  withMargin: _propTypes.default.bool
} : {};
Toolbar.defaultProps = {
  disableGutters: false,
  sticky: false,
  withMargin: false
};

var _default = (0, _withStyles.default)(styles, {
  name: 'MuiToolbar'
})(Toolbar);

exports.default = _default;