"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = getCalendarTheme;

function getCalendarTheme(theme) {
  return {
    Calendar: {
      fontFamily: theme.typography.fontFamily,
      padding: theme.spacing.xsmall,
      paddingTop: 0,
      color: theme.palette.text.primary
    },
    MonthAndYear: {
      fontSize: theme.typography.subheading.fontSize,
      marginBottom: 0,
      padding: [[theme.spacing.xsmall, theme.spacing.small]],
      boxSizing: 'content-box',
      display: 'flex',
      justifyContent: 'space-between',
      alignItems: 'center'
    },
    MonthButton: {
      background: theme.palette.common.minBlack,
      margin: 0,
      float: 'none',
      cursor: 'pointer'
    },
    MonthArrowPrev: {
      borderRightColor: theme.palette.common.white
    },
    MonthArrowNext: {
      borderLeftColor: theme.palette.common.white
    },
    DaySelected: {
      background: theme.palette.primary.main
    },
    DayInRange: {
      background: theme.palette.primary.light,
      color: theme.palette.common.white
    },
    DayHover: {
      background: theme.palette.primary.dark,
      color: theme.palette.common.white
    },
    DayActive: {
      background: theme.palette.primary.dark
    },
    DayPassive: {
      background: 'transparent',
      color: theme.palette.common.minBlack
    }
  };
}