"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/builtin/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = createReduxFormComponent;

var _objectSpread2 = _interopRequireDefault(require("@babel/runtime/helpers/builtin/objectSpread"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/builtin/objectWithoutProperties"));

var _mapProps = _interopRequireDefault(require("recompose/mapProps"));

function createReduxFormComponent(Component) {
  return (0, _mapProps.default)(function (_ref) {
    var defaultValue = _ref.defaultValue,
        _ref$input = _ref.input,
        value = _ref$input.value,
        onFocus = _ref$input.onFocus,
        _onChange = _ref$input.onChange,
        _onBlur = _ref$input.onBlur,
        meta = _ref.meta,
        _ref$meta = _ref.meta,
        touched = _ref$meta.touched,
        error = _ref$meta.error,
        warning = _ref$meta.warning,
        onChangeProp = _ref.onChange,
        helperText = _ref.helperText,
        other = (0, _objectWithoutProperties2.default)(_ref, ["defaultValue", "input", "meta", "meta", "onChange", "helperText"]);
    return (0, _objectSpread2.default)({}, other, {
      value: value,
      onFocus: onFocus,
      onChange: function onChange() {
        var newValue = (arguments.length <= 0 ? undefined : arguments[0]) instanceof Event ? arguments.length <= 1 ? undefined : arguments[1] : arguments.length <= 0 ? undefined : arguments[0];

        _onChange(newValue);

        if (onChangeProp) {
          onChangeProp(newValue);
        }
      },
      onBlur: function onBlur() {
        return _onBlur(value);
      },
      // allow empty strings to appear as error
      error: Boolean(touched && (error != null || warning != null)),
      helperText: touched && (error || warning) || helperText
    });
  })(Component);
}